###############################################################################
## OCSINVENTORY-NG 
## Copyleft Pascal DANEK 2005
## Web : http://ocsinventory.sourceforge.net
##
## This code is open source and may be copied and modified as long as the source
## code is always made freely available.
## Please refer to the General Public Licence http://www.gnu.org/ or Licence.txt
################################################################################
package Ocsinventory::Agent::Option::Ipdiscover;

use strict;

require Exporter;

our @ISA = qw /Exporter/;

our @EXPORT = qw/
	ipdiscover_prolog_reader
	ipdiscover_inventory_handler
/;

use XML::Simple;
use Ocsinventory::Agent::Common qw /_get_path/;

sub ipdiscover_prolog_reader{
	my $current_context = shift;
	my $prolog = shift;
	$prolog = XML::Simple::XMLin( $prolog, ForceArray => ['OPTION'] );
	
	# Options management (ipdiscover only is implemented at this time)
	for(@{$prolog->{OPTION}}){
		if( $_->{NAME} =~/ipdiscover/i){
			$current_context->{'OCS_OPTION_IPDISCOVER'} = $_->{PARAM};
		}
	}
}

sub ipdiscover_inventory_handler{
	my $current_context = shift;
	my $request = shift;
	
	my $ipdiscover_path = &_get_path("ipdiscover");
	
	if($current_context->{'OCS_OPTION_IPDISCOVER'}){
		my ($iface,$ipdiscover);

		#We get the iface name for the related subnet
		for(@{$request->{'CONTENT'}->{'NETWORKS'}}){
			if($_->{'IPSUBNET'}[0] eq $current_context->{'OCS_OPTION_IPDISCOVER'}){
				$iface = $_->{'DESCRIPTION'}[0];
				last;
			}
		}
		return if(!$iface or !$ipdiscover_path);
		#and we launch the ipdiscover
		$ipdiscover = `$ipdiscover_path $iface`;

		if($ipdiscover){
			$request->{'CONTENT'}->{'IPDISCOVER'} = XML::Simple::XMLin( $ipdiscover, ForceArray => 'H');
		}

	}
}
1;